/*****************************************************************************/
/*	         							     */
/*									     */
/*    *****			  ***** 				     */
/*	 *****			*****					     */
/*	   *****	      *****					     */
/*	     *****	    *****					     */
/*  ***************	  ***************				     */
/*  *****************	*****************				     */
/*  ***************	  ***************				     */
/*	     *****	    *****	   TheNet       		     */
/*	   *****	      *****	   Portable. Compatible.	     */
/*	 *****			*****	   Public Domain		     */
/*    *****			  *****    NORD><LINK	 		     */
/*									     */
/* This software is public domain ONLY for non commercial use                */
/*                                                                           */
/*									     */
/*****************************************************************************/

/*** Variable fuer Level 7                                                   */

/* G8KBB April 1991 - modified to put in a static pointer to the stack end
 *                  - include STATS command conditionally on STATSCMD
 *                  - include optionally KISS & HOST mode cmds
 *                  - include optional CWID support
 *                  - change Tpar to char 
 */

/*
 * Released as TheNet X-1J, September 1993
 *
 * add port flush support
 * add l3 heard list support
 *
 * Released as TheNet X-1J release 4, January 1995
 */

EXTERN cirtyp   cirtab[NUMCIR];        /* Circuit Tabelle                           */
EXTERN cirtyp   *cirpoi;               /* Pointer in Circuit Tabelle                */

EXTERN char     *clipoi;               /* Pointer in CLI Zeile                      */
EXTERN char     clilin[80];            /* Zeile fuer CLI                            */

EXTERN char     paswrd[80];            /* Passwort                                  */
EXTERN char     infmsg[160];           /* Info-String                               */

EXTERN char     usrcal[7];             /* Call des aktuellen Users                  */
EXTERN char     ncall[7];              /* Call des Nachbarn                         */
EXTERN char     ndigi[57];             /* Digiliste zum Nachbarn                    */
EXTERN char     nport;                 /* Port des Nachbarn                         */

EXTERN unsigned clicnt;                /* Zaehler fuer Zeichen in CLI Zeile         */
EXTERN unsigned paswle;                /* Laenge des Passworts                      */

EXTERN unsigned ininat;                /* no activity timeout                       */
EXTERN unsigned conctl;                /* congestion control                        */
EXTERN BOOLEAN  VCpar;                 /* Call ueberpruefen Flag                    */
EXTERN unsigned beacen;                /* Beacon enable Flag                        */
EXTERN BOOLEAN  cqen;                  /* CQ-Ruf enable Flag                        */
EXTERN unsigned nquali;                /* Qualitaet des Knotens                     */
EXTERN unsigned tic10;                 /* RTC, 10ms Increment                       */
EXTERN unsigned lastic;                /* Zeitpunkt des letzten Timerservice        */
EXTERN unsigned tic1s;                 /* zaehlt Zeit bis 1s, wird dann rueckgesetzt*/
EXTERN unsigned beatim;                /* Zeitzaehler fuer Bake, 1s Increment       */
EXTERN unsigned Tpar;                  /* Sendeverzoegerung                         */
EXTERN unsigned Ppar;                  /* Entschlossenheit fuer Sendung             */
EXTERN unsigned Wpar;                  /* Zeitscheibengroesse                       */
EXTERN unsigned Dpar;                  /* Full-Duplex Flag                          */
EXTERN char     xFpar;                 /* Flags bei Fullduplex senden               */

EXTERN lhtyp    usccpl;                /* Kopf der CCP-User Liste                   */
EXTERN lhtyp    userhd;                /* Kopf der User Liste                       */
EXTERN usrtyp   *userpo;               /* Pointer in User Liste                     */

EXTERN ptctyp   ptcrdl[NUMPAT];        /* Patchcord Liste                           */
EXTERN ptctyp   *ptcrdp;               /* Pointer in Patchcord Liste                */

EXTERN char     bline[BLINLEN+1];            /* Zeile vom Hostinterface                   */
EXTERN char     *blipoi;               /* Pointer in bline                          */
EXTERN char     blixfl;                /* X-on / X-off Flag fuer Hostinterface      */
#ifndef MODIFIED
EXTERN char     hostco;                /* Flag Hostconnect erlaubt j/n              */
#endif
EXTERN unsigned blicnt;                /* zaehlt Zeichen in bline                   */
EXTERN int      magicn;                /* Pruefziffer fuer Warm-Kalt-Start          */
EXTERN hustyp   hstubl[MAXHST];        /* Kontrollblock fuer Host-User              */
EXTERN hustyp   *hstusr;               /* Pointer auf aktuellen Host User           */
EXTERN char     stackb[STACKLEN];      /* Systemstack                               */
#ifdef VARIABLES
EXTERN char	*stkend = stackb+sizeof(stackb)-2; /* compiler independant code        */
#endif
#ifdef IGNORE_THIS
EXTERN char     stack;
EXTERN char     fremem;                /* Anfang des freien Speichers               */
#endif

#ifdef STATSCMD
EXTERN unsigned     	txstat[NUM1STATS];	/* percent time tx was on per 5mins */
EXTERN unsigned     	rxstat[NUM1STATS];	/* ditto for DCD on */
EXTERN unsigned		txon, dcdon;		/* counter in 10 ms intervals */
EXTERN unsigned		usetim;				/* timer for usage updates for stats */
EXTERN unsigned        minbuf[NUM1STATS];
EXTERN unsigned        cpucnt[NUM1STATS];
EXTERN unsigned        cpuload; 
EXTERN unsigned char   cpu2load;
EXTERN unsigned        minfre;
#endif

#ifdef KISSMODE
EXTERN unsigned  crlmod;
#endif

#ifdef HOSTMODE
EXTERN unsigned  hstmod;
EXTERN unsigned  char hststs;
EXTERN unsigned  char hotout;
EXTERN unsigned  char hostid[10];
EXTERN unsigned  char hidlen;
#ifdef MODIFIED
EXTERN unsigned  char hostalias[7];
#endif
#endif

#ifdef HOSTCMD
EXTERN unsigned  char bbsid[10];
EXTERN unsigned  char bbslen;
#ifdef MODIFIED
EXTERN unsigned  char bbsalias[7];
#endif
#ifdef DXCLUSTER
EXTERN unsigned  char dxcid[10];
EXTERN unsigned  char dxclen;
#ifdef MODIFIED
EXTERN unsigned  char dxcalias[7];
#endif
#endif
#endif

#ifdef MONITORCMD
EXTERN lhtyp heardl;
EXTERN unsigned seconds;
EXTERN unsigned char mhlcount;
#ifdef L3MONITOR
EXTERN lhtyp l3heardl;
EXTERN unsigned char l3mhlcnt;
#endif
#endif

#ifdef MODIFIED
EXTERN unsigned brochn;
EXTERN unsigned char defcsr[ 48 ];		/* warning !! must be >= sizeof( defcst ) */
EXTERN unsigned beaint, ctobbs;
EXTERN char beatxt[80];
EXTERN char contxt[80];
EXTERN unsigned hlpflg;
EXTERN unsigned enaliases;
EXTERN unsigned nohashnode;
EXTERN unsigned reconnect;
EXTERN unsigned no_slime;
EXTERN unsigned no_digi;
#endif

#ifdef MANAGED
EXTERN unsigned auditmask;
#endif

#ifdef ACL
EXTERN ACLMB acl;
EXTERN unsigned char acl_default;
EXTERN unsigned char acl_mask;
EXTERN ACLMB *aclcur;
EXTERN ACLENTRY *aclentry;
#endif

#ifdef METERS
EXTERN unsigned rxdev;
EXTERN unsigned meterflags;
EXTERN unsigned rxsigmin;
EXTERN unsigned rxsmeter;
EXTERN unsigned rxdb;
EXTERN signed dbfloor;
EXTERN unsigned adcmult1;
EXTERN unsigned adcmult2;
EXTERN unsigned adcofs1;
EXTERN unsigned adcofs2;
EXTERN char units1[13];
EXTERN char units2[13];
#ifdef ALL_METERS
EXTERN unsigned adcmult3;
EXTERN unsigned adcmult4;
EXTERN unsigned adcofs3;
EXTERN unsigned adcofs4;
EXTERN char units3[13];
EXTERN char units4[13];
#endif
#endif

#ifdef MOD_MTU
EXTERN unsigned mtu_ip0;
EXTERN unsigned mtu_ip1;
EXTERN unsigned mtu_ipn;
EXTERN unsigned mtu_i_max;
EXTERN unsigned mtu_l2_max;
#endif

#ifdef PORTFLUSH
EXTERN unsigned char none_last_time[NUMPORTS];
EXTERN unsigned char pending[NUMPORTS];
EXTERN unsigned char sentdata[NUMPORTS];
EXTERN unsigned flushed[NUMPORTS];
#endif

/*** Ende tnl7av.c                                                         ***/
